﻿using Infragistics.UltraChart.Resources;
using Infragistics.UltraChart.Shared.Styles;
using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace CustomHistogramChart
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            int[] intArray = new int[]{ 1, 9, 13, 5, 6, 7, 8, 9, 9, 9, 12, 13, 14, 15, 16 };
            this.ultraChart1.Data.DataSource = intArray;
            this.ultraChart1.Data.DataBind();
            this.ultraChart1.ChartType = ChartType.HistogramChart;
            this.ultraChart1.HistogramChart.ColumnAppearance.StringAxis = false;
            this.ultraChart1.Axis.X.TickmarkStyle = AxisTickStyle.DataInterval;
            this.ultraChart1.Axis.X.Labels.Orientation = TextOrientation.Horizontal;
            this.ultraChart1.Axis.X.RangeMin = 0;
            this.ultraChart1.Axis.X.RangeMax = 20;

            this.ultraChart1.Axis.X.TickmarkInterval = 5;
            this.ultraChart1.Axis.X.RangeType = AxisRangeType.Custom;

            this.ultraChart1.Axis.Y.RangeMin = 0;
            //Count your data.
            this.ultraChart1.Axis.Y.RangeMax = intArray.Count();
            this.ultraChart1.Axis.Y.RangeType = AxisRangeType.Custom;

            
            this.ultraChart1.Axis.X.Labels.ItemFormatString = "<MY_VALUE>";
            Hashtable MyLabelHashTable = new Hashtable();
            MyLabelHashTable.Add("MY_VALUE", new MyLabelRenderer());
            this.ultraChart1.LabelHash = MyLabelHashTable;

        }
    }
    public class MyLabelRenderer : IRenderLabel
    {
        public string ToString(Hashtable context)
        {
            double dataValue = (double)context["DATA_VALUE"];
            if (dataValue == 20)
                return "20-25";
            else if (dataValue == 15)
                return "15-20";
            else if (dataValue == 10)
                return "10-15";
            else if (dataValue == 5)
                return "5-10";
            else
                return "0-5";
        }
    }

}
